// TCP/IP Stack Javascript Library. http://www.kernelchip.ru
var timeOutMS = 15000;
var ajaxList = new Array();

function newAJAXCommand(url, container, repeat, data) {	
var newAjax = new Object();
var theTimer = new Date();
newAjax.url = url;
newAjax.container = container;
newAjax.repeat = repeat;
newAjax.ajaxReq = null;		
	if(window.XMLHttpRequest) {
        newAjax.ajaxReq = new XMLHttpRequest();
        newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
        newAjax.ajaxReq.send(data); 
    } else if(window.ActiveXObject) {
        newAjax.ajaxReq = new ActiveXObject("Microsoft.XMLHTTP");
        if(newAjax.ajaxReq) {
            newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
            newAjax.ajaxReq.send(data);
        }
    }    
    newAjax.lastCalled = theTimer.getTime();   
    ajaxList.push(newAjax);
}

function pollAJAX() {	
	var curAjax = new Object();
	var theTimer = new Date();
	var elapsed;	
	for(i = ajaxList.length; i > 0; i--)	{
		curAjax = ajaxList.shift();
		if(!curAjax)
			continue;
		elapsed = theTimer.getTime() - curAjax.lastCalled;	
		if(curAjax.ajaxReq.readyState == 4 && curAjax.ajaxReq.status == 200) {			
		  if(typeof(curAjax.container) == 'function'){
		    if (curAjax.ajaxReq.responseXML) curAjax.container(curAjax.ajaxReq.responseXML.documentElement);
		    else if (curAjax.ajaxReq.response) curAjax.container(curAjax.ajaxReq.response);
		  } 
      else if(typeof(curAjax.container) == 'string') {
		    document.getElementById(curAjax.container).innerHTML = curAjax.ajaxReq.responseText;
		  } 			
	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;			
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}			
		if(elapsed > timeOutMS) {			
			if(typeof(curAjax.container) == 'function'){
				curAjax.container(null);
			} else {}
	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;						
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}		
		ajaxList.push(curAjax);
	}	
	setTimeout( "pollAJAX()", 750 );	
}

function getXMLValue(xmlData, field) {
	try {
		if(xmlData.getElementsByTagName(field)[0].firstChild.nodeValue)
			return xmlData.getElementsByTagName(field)[0].firstChild.nodeValue;
		else return null;
	} catch(err) { return null; }
}
setTimeout("pollAJAX()", 500);

function toRusHex( str ) {
	var hex = '';
	for(var i = 0; i < str.length; i++) {      
    var _code = str.charCodeAt(i);
    if( _code >= 1040 && _code <= 1103 ) _code = _code - 1040 + 192;
    hex += ''+_code.toString(16);
	}
	return hex;
}

function hex2aRus(hexx) {
  var hex = hexx.toString();
  var str = '';
  for (var i = 0; (i < hex.length && hex.substr(i, 2) !== '00'); i += 2) {  
    var intH = parseInt( hex.substr(i, 2), 16); 
    if( intH >= 192 && intH <= 255 ) { 
      intH = intH - 192 + 1040;
    }       
    str += String.fromCharCode( intH );    
  }
  return str;
}

function hex2a(hexx) {
  var hex = hexx.toString();
  var str = '';
  for (var i = 0; (i < hex.length && hex.substr(i, 2) !== '00'); i += 2)
    str += String.fromCharCode(parseInt(hex.substr(i, 2), 16));
  return str;
}


//
var JSN_BASIC_SET  = 0;
var JSN_SENSOR_VAL = 1;
var JSN_HW_SET     = 2;
var JSN_RT_STATUS  = 3;
var JSN_HW_NAMES   = 4;
var JSN_1W_BBU     = 5;
var JSN_1W_RAM     = 6;
var JSN_CATL_SET   = 7;
var JSN_CATL_STAT  = 8;
var JSN_TOTAL      = 9;
  
var JSN_TXT = [ 
"JSN_BASIC_SET",
"JSN_SENSOR_VAL",
"JSN_HW_SET",
"JSN_RT_STATUS",
"JSN_HW_NAMES",
"JSN_1W_BBU",
"JSN_1W_RAM",
"JSN_CATL_SET",
"JSN_CATL_STAT",
"JSN_TOTAL"
]; 

// HW ids
var HW_ITEM_BEGGINING  = 0;
var HW_ITEM_RELE_1     = 1;
var HW_ITEM_RELE_2     = 2;
var HW_ITEM_RELE_3     = 3;
var HW_ITEM_RELE_4     = 4;
var HW_ITEM_ISO_IN_1   = 5;
var HW_ITEM_ISO_IN_2   = 6;
var HW_ITEM_ISO_IN_3   = 7;
var HW_ITEM_ISO_IN_4   = 8;
var HW_ITEM_ISO_IN_5   = 9;
var HW_ITEM_ISO_IN_6   = 10;
var HW_ITEM_ISO_OUT_1  = 11;
var HW_ITEM_ISO_OUT_2  = 12;
var HW_ITEM_ISO_OUT_3  = 13;
var HW_ITEM_ISO_OUT_4  = 14;
var HW_ITEM_ISO_OUT_5  = 15;
var HW_ITEM_ISO_OUT_6  = 16;
var HW_ITEM_ISO_OUT_7  = 17;
var HW_ITEM_ISO_OUT_8  = 18;
var HW_ITEM_ISO_OUT_9  = 19;
var HW_ITEM_ISO_OUT_10 = 20;
var HW_ITEM_ISO_OUT_11 = 21;
var HW_ITEM_ISO_OUT_12 = 22;
var HW_ITEM_ADC_1      = 23;
var HW_ITEM_ADC_2      = 24;
var HW_ITEM_TOTAL      = 25;
  
var def_hw_names = new Array();
for (var i = 0; i <= HW_ITEM_TOTAL; i++) {
  def_hw_names[i] = "?";
}

def_hw_names[ HW_ITEM_BEGGINING ]  = "-"; 
def_hw_names[ HW_ITEM_RELE_1    ]  = "RELE_1"; 
def_hw_names[ HW_ITEM_RELE_2    ]  = "RELE_2"; 
def_hw_names[ HW_ITEM_RELE_3    ]  = "RELE_3"; 
def_hw_names[ HW_ITEM_RELE_4    ]  = "RELE_4"; 
def_hw_names[ HW_ITEM_ISO_IN_1  ]  = "IN_1"; 
def_hw_names[ HW_ITEM_ISO_IN_2  ]  = "IN_2"; 
def_hw_names[ HW_ITEM_ISO_IN_3  ]  = "IN_3"; 
def_hw_names[ HW_ITEM_ISO_IN_4  ]  = "IN_4"; 
def_hw_names[ HW_ITEM_ISO_IN_5  ]  = "IN_5"; 
def_hw_names[ HW_ITEM_ISO_IN_6  ]  = "IN_6"; 
def_hw_names[ HW_ITEM_ISO_OUT_1 ]  = "OUT_1"; 
def_hw_names[ HW_ITEM_ISO_OUT_2 ]  = "OUT_2"; 
def_hw_names[ HW_ITEM_ISO_OUT_3 ]  = "OUT_3"; 
def_hw_names[ HW_ITEM_ISO_OUT_4 ]  = "OUT_4"; 
def_hw_names[ HW_ITEM_ISO_OUT_5 ]  = "OUT_5"; 
def_hw_names[ HW_ITEM_ISO_OUT_6 ]  = "OUT_6"; 
def_hw_names[ HW_ITEM_ISO_OUT_7 ]  = "OUT_7"; 
def_hw_names[ HW_ITEM_ISO_OUT_8 ]  = "OUT_8"; 
def_hw_names[ HW_ITEM_ISO_OUT_9 ]  = "OUT_9"; 
def_hw_names[ HW_ITEM_ISO_OUT_10 ] = "OUT_10"; 
def_hw_names[ HW_ITEM_ISO_OUT_11 ] = "OUT_11"; 
def_hw_names[ HW_ITEM_ISO_OUT_12 ] = "OUT_12"; 
def_hw_names[ HW_ITEM_ADC_1     ]  = "ADC_1"; 
def_hw_names[ HW_ITEM_ADC_2     ]  = "ADC_2"; 
def_hw_names[ HW_ITEM_TOTAL     ]  = "-";




var HW_MIN_RELE_ID = HW_ITEM_RELE_1;
var HW_MAX_RELE_ID = HW_ITEM_RELE_4;

var HW_MIN_ISO_IN_ID = HW_ITEM_ISO_IN_1;
var HW_MAX_ISO_IN_ID = HW_ITEM_ISO_IN_6;

var HW_MIN_ISO_OUT_ID = HW_ITEM_ISO_OUT_1;
var HW_MAX_ISO_OUT_ID = HW_ITEM_ISO_OUT_12;

var HW_MIN_ADC_ID = HW_ITEM_ADC_1;
var HW_MAX_ADC_ID = HW_ITEM_ADC_2;


var MODULE_UNKNOWN    = 0;
var MODULE_LAURENT_5  = 1;
var MODULE_LAURENT_5G = 2;
var MODULE_MODELS = [ "?", "Laurent-5", "Laurent-5G" ];

// HW limits
var ADC_CHAN_NUM    = 2;
var MAX_INPUT_LINE  = 6;
var IN_LINES_NUM    = 6;
var GPIO_LINES_NUM  = 0;
var OUT_LINES_NUM   = 12;
var RELE_NUM        = 4;
var TMPERATURE_NUM  = 1; 
var PWM_NUM         = 1; 
var ISO_IN_LINES    = 6;


function TMP_RAM_Object() {
  this.val = -273.0;
  this.adr = new Array();
  for (var i = 0; i < 8; i++) {
    this.adr[i] = 0;
  }
  this.bus = "";  
}

function TMP_BBU_Object() {
  this.adr = new Array();
  for (var i = 0; i < 8; i++) {
    this.adr[i] = 0;
  }
  this.name = "";  
}

// CATL
var MAX_NUMBER_OF_CATL_OBJ = 10;
var CATL_REMHOST_TXT_SIZE  = 31;

var CATL_OWN_MODULE    = 0;
var CATL_REM_MODULE    = 1;
var CATL_REM_HTTP_HOST = 2;
var CATL_REM_TCP_HOST  = 3;
var CATL_DEST_TOTAL    = 4;

var _OFFSET_RELE = 0;
var _OFFSET_OUT  = 32;
var _OFFSET_IO   = 64;

function CATL_Slot() {
  this._id        = 0;
  this.eSlot      = 0;
  this.bEnabled   = 0;     
  this.line       = 0;         
  this.evt_type   = 0;     
  this.evt_porog  = 0;   
  this.evt_host   = 0;    
  this.reac_line  = 0;   
  this.reac_val   = 0;  
  this.reac_delay = 0; 
  
  this.rem_ip   = "";
  this.rem_port = "";
  this.rem_txt  = "";
  
  this.cnt = 0;
}

function CATL_Object() {
  this.host_ip  = "";
  this.host_psw = "";
  this.slots = new Array();
}

var _msg_txt = [   
  "EIN", 
  "TIME",
  "RELE",
  "IN",
  "OUT",  
  "ADCV",
  "PWM",
  "1WT"
];

var MSG_TYPE_EVENT  = 0;
var MSG_TYPE_ONTIME = 1;
  
var TOTAL_NUMBER_OF_MSG = _msg_txt.length;

function MSG_Object() {  
  this.name = "";
  this.mask = 0;  
}

var TCP_SERVER_PORT = 0;     
var TCP_CLIENT_PORT = 1;        
var USART1_PORT     = 2;        
var WEB_PORT        = 3;         
var NULL_PORT       = 4;         
var URL_PORT        = 5;
var TOTAL_NUM_PORT  = 6;

var OWI_BUS_NUMBER = 1; 
var OWI_BUS_A = 0;
var OWI_BUS_B = 1;

var OWI_FUNC_NONE    = 0;
var OWI_FUNC_DS18B20 = 1;     
var OWI_FUNC_DTH11   = 2;     
var OWI_FUNC_IBUTTON = 3;  
var OWI_FUNC_DTH22   = 4;  
  
function OWI_BUS_Object() {  
  this.mode    = 0;        
  this.dev_num = 0;  
  this.pwr     = true;
  this.rst_cnt = 0;
}


 
function JSN_TAB_Object() {  
  this._perv = -2;        
  this._new  = -1;
}

function SAV_Object() {  
  this.bSAV = 0;
  this.sav_rel = 0;    
  this.sav_out = 0;
  this.per = 0;
}

function KECLO_Object() {  
  this.enab = 0;        
  this.key  = "";
  this.per_beep = -1;
  this.per_data = -1;
  
  this.stat = -1;
  this.con_good = 0;
  this.con_bad  = 0;
  this.bRestricted = 0;
  this.allow_rate = 0;
  this.msg = "";
}

var CLO_KEY_LEN = 32;

var CLO_ERR_NOERR = 0;
var CLO_ERR_NOKEY = 1;
var CLO_ERR_CANTCON = 2;
var CLO_ERR_START_CON = 3;  
var CLO_ERR_CON_GOOD  = 4;
var CLO_ERR_BAD_AUTH_KEY = 5;
var CLO_ERR_BAD_AUTH_SN = 6;
var CLO_ERR_SRV_ERR = 7;
var CLO_ERR_PAYMENT = 8;
var CLO_ERR_OLD_FW = 9;

function LaurentObject() {
  
  this.Connected  = 0;      
  this.time      =  0;
  this.sn        = "";
  this.fw        = "";  
  this.hw        = "";

  this.pwm       = -1; 
  this.temp      = 0;  
   
  this.pass = "";
  this.ip   = "";
  this.mac  = "";
  this.mask = "";
  this.gate = "";  
  this.nbn  = "";
  this.dhcp = 0;
  
  this.security = 0;
  this.psw_need = 0;  
  this.dzg_in   = 0;  
  
  
  this.jsn_tab = new Array();
  for (var i = 0; i < JSN_TOTAL; i++) {
    this.jsn_tab[i] = new JSN_TAB_Object();
    this.jsn_tab[i]._perv = -1;
    this.jsn_tab[i]._new  = -1;
  }     
   
  this.tcp_port  = new Array();  
  for (i = 0; i < 3; i++) this.tcp_port[i] = 0; 
  
  this.adc_raw   = new Array();
  this.adc_fl    = new Array();
  this.adc_coef  = new Array();
  for (i = 0; i < ADC_CHAN_NUM; i++) {
    this.adc_raw[i]  = 0; 
    this.adc_fl[i]   = 0; 
    this.adc_coef[i] = 1.0;  
  }
  
  this.iso_in  = new Array();
  this.impl_in = new Array();
  for(i = 0; i < IN_LINES_NUM; i++ ) {
    this.iso_in[i]  = 0;
    this.impl_in[i] = 0;
  }
    
  this.iso_out = new Array();
  for(i = 0; i < OUT_LINES_NUM; i++ ) {
    this.iso_out[i] = 0;
  }
   
  this.rele = new Array();    
  for(i = 0; i < RELE_NUM; i++)  {    
    this.rele[i] = 0;    
  }
    
  this.unm  = new Array();
  for(i = 0; i < HW_ITEM_TOTAL; i++)  {     
    this.unm[i] = def_hw_names[i];
  }    
  
  this.temp_ram = new Array();
  this.temp_bbu = new Array();
  this.temp_new = new Array();  //?//
  this.bbu_new  = new Array();  //?//
  
  for (var i = 0; i < TMPERATURE_NUM*OWI_BUS_NUMBER; i++) {
    this.temp_ram[i] = new TMP_RAM_Object();
    this.temp_bbu[i] = new TMP_BBU_Object();
    
    this.temp_new[i] = 0; //?//
    this.bbu_new[i]  = 0; //?//
  }
  this.bTEMP_RAM_New  = 0;
  this.bTEMP_BBU_New  = 0;
  this.TEMP_RAM_Count = 0; //?//
  this.TEMP_BBU_Count = 0; //?//
  
  this.usart_baud_idx = 7;  // 115200 by def
  
  // PWM 
  this.pwm_mask = new Array();
  this.pwm_val  = new Array();
  for (i = 0; i < PWM_NUM; i++) {
    this.pwm_mask[i] = 0; 
    this.pwm_val[i]  = 0;
  }
  this.pwm_frq = 0;
  
  // CATL
  this.catl = new CATL_Object();
  for (i = 0; i < MAX_NUMBER_OF_CATL_OBJ; i++) {
    this.catl.slots[i] = new CATL_Slot();    
  }
  
    
  this.msg_base = new Array();  
  for(i = 0; i < TOTAL_NUMBER_OF_MSG; i++) {
    this.msg_base[i] = new MSG_Object();    
    this.msg_base[i].name = _msg_txt[i];
    this.msg_base[i].mask = 0;
  } 
    
  this.sav = new SAV_Object();  
  this.clo = new KECLO_Object();
    
  this.IsConnected = function() { return this.Connected; }
  this.GetTime = function() { return this.time; }   
  this.GetFW   = function() { return this.fw; }    
  this.GetPass = function() { return this.pass; }
  this.GetIP   = function() { return this.ip; }
  this.GetMAC  = function() { return this.mac; } 
  this.GetMask = function() { return this.mask; } 
  this.GetGate = function() { return this.gate; } 
  
  var srv = "server.cgi?data";  
 
  this.SetPass = function(value) {  
    newAJAXCommand(srv+'=PSW,NEW,' + value);
  }
  this.SetIP = function(value) { 
    newAJAXCommand(srv+'=IP,SET,' + value);
  }
  this.SetMAC = function(value) { 
    newAJAXCommand(srv+'=MAC,SET,' + value);
  }  
  this.SetMSK = function(value) { 
    newAJAXCommand(srv+'=MSK,SET,' + value);
  }  
  this.SetGTW = function(value) { 
    newAJAXCommand(srv+'=GTW,SET,' + value);
  }
  this.Set_DHCP  = function(value) { 
    newAJAXCommand(srv+'=DHCP,SET,' + value);
  }
  this.SetNBN = function(value) { 
    newAJAXCommand(srv+'=NBN,SET,' + value);
  }
  this.Reset = function() {
    newAJAXCommand(srv+'=RST');
  }
  this.Default = function() {
    newAJAXCommand(srv+'=DEFAULT');
  }     
  this.SetTCP_Port = function( port, val ) { 
    newAJAXCommand( srv + '=PRT,' + port + ",SET," + val ); 
  }  
  this.SetRele = function(ReleIdx) {     
    newAJAXCommand( srv + '=REL,' + ReleIdx + ',2' ); 
  }   
  this.SetOut = function( Idx ) { 
    newAJAXCommand( srv + '=WR,' + Idx + ',2' ); 
  }
  this.Set_HW_Name = function( idx, str ) {         
    newAJAXCommand(srv+'=UNM,' + idx + ',H,SET,' + toRusHex(str) );
  }   
  this.SetSEC = function( val ) {     
    newAJAXCommand( srv + '=SEC,SET,' + val );
  }
  this.SendUSART_HEX = function(value) {
    newAJAXCommand(srv+'=PUT,U,H,' + value );
  }
  this.SetBaud = function( val ) { 
    newAJAXCommand( srv + '=SPB,SET,' + val );
  }    
  this.SetUSART_Mode = function( val ) { 
    newAJAXCommand( srv + '=SER,MOD,SET,' + val );
  } 
  this.SetUSART_BITS  = function( dbits, sbits, parity ) { 
    newAJAXCommand( srv + '=SER,BITS,SET,' + dbits + ',' + sbits + ',' + parity );
  }  
  
  this.SetPWM_Val = function (_idx, _val){
    newAJAXCommand(srv+'=PWM,SET,' + _val );
  }
  
  this.TempSCAN = function () {
    newAJAXCommand(srv+'=TMP,SCAN');
  }
  
  this.TempDEL_BBU = function (_id) {    
    newAJAXCommand(srv+'=TMP,TAB,' + _id + ',DEL' );    
  }
  
  this.TempDEL_ALL_BBU = function () {
    newAJAXCommand(srv + '=TMP,TAB,DEL,ALL');
  }
  
  this.TempSAV_BBU = function (_adr_hex, name) {    
    newAJAXCommand(srv + '=TMP,TAB,-1,SET,' + _adr_hex + ',' + toRusHex( name ) );
  }  
  this.SetCAT_I_Action = function( idx, action ) {     
    newAJAXCommand(srv+'=CTL,' + idx + ',ACT,' + action );  
  }
  this.MSG_Enab = function( port_char, _msg, state ) {    
    newAJAXCommand( srv+'=MSG,' + port_char + ',' + _msg + ',SET,' + state );
  }    
  this.SetCLO_KEY = function(value) {    
    newAJAXCommand( srv+'=CLO,KEY,SET,' + value );
  } 
  this.SetCLO_Mode = function(value) {    
    newAJAXCommand( srv+'=CLO,MOD,SET,' + value );
  } 
  this.SetCLO_PER_TICK = function(value) {    
    newAJAXCommand( srv+'=CLO,PERT,SET,' + value );
  }    
  this.SetLCD_CNT_Reset = function() {    
    newAJAXCommand( srv+'=CLO,CNT,RST' );
  } 
  
  this.UpdateSAV_PER = function( _val ) {  
    newAJAXCommand( srv+'=SAV,PER,SET,' + _val );
  }  
  this.UpdateSAV_HW = function( _txt, state ) {  
    newAJAXCommand( srv+'=SAV,' + _txt + ',SET,' + state );
  } 
  this.UpdateSAV_CLN = function(  ) {  
    newAJAXCommand( srv+'=SAV,CLN' );
  }   
  this.UpdateDZG = function( _val ) {  
    newAJAXCommand( srv+'=DZG,SET,' + _val );
  }   

  this.SetCATL = function( _slot ) {
    
    var _host = _slot.evt_host;  
    
    var _cmd = new Array();
    _cmd[0] = srv + '=CTL,' + _slot._id + ',' + _slot.eSlot + ',' + _slot.line + ',' + _slot.evt_type + ',' + _slot.evt_porog + ',' + _host;
    _cmd[1] = srv + '=CTL,' + _slot._id + ',HST,';
    _cmd[2] = srv + '=CTL,' + _slot._id + ',DAT,'; 
    
    if( 
    _host == CATL_OWN_MODULE ||
    _host == CATL_REM_MODULE    
    ) 
    {
      _cmd[0] += ',' + _slot.reac_line + ',' + _slot.reac_val;        
      if( _slot.reac_delay > 0 ) _cmd[0] += ','+ _slot.reac_delay;
      
      if( _host == CATL_REM_MODULE ) 
      {
        _cmd[1] += _slot.rem_ip + ',' + _slot.rem_port;
        _cmd[2] += toRusHex(_slot.rem_txt);
      }
    }
    else if(     
    _host == CATL_REM_HTTP_HOST ||
    _host == CATL_REM_TCP_HOST
    ) 
    {
      // nothing...
      _cmd[1] += _slot.rem_ip + ',' + _slot.rem_port;
      _cmd[2] += toRusHex(_slot.rem_txt);
    }       
    
    setTimeout( newAJAXCommand, 0,    _cmd[0] );
    if(_host != CATL_OWN_MODULE) 
    {      
      setTimeout( newAJAXCommand,  500, _cmd[1] );
      setTimeout( newAJAXCommand, 1000, _cmd[2] ); 
    }
  }
      
  this.UpdateStatus = function(xmlData){   
  if( !xmlData ) { this.Connected = 0; return; }  
  
  this.Connected = 1;
  var TempLoc;   

  TempLoc = getXMLValue( xmlData, 'systime0' );
  if( TempLoc ) {
    var str = TempLoc;
    var tagList = str.split(".");
    
    this.time     = parseInt(tagList[0]);
    var roll_cnt  = parseInt(tagList[1]);  

    this.time += roll_cnt * 32766;
  }    

  TempLoc = getXMLValue( xmlData, 'jsn_tab0' );
  if( TempLoc ) {
    var str = TempLoc;
    var tagList = str.split(".");
	
    var _expected = parseInt(tagList[0]);
    if( _expected != JSN_TOTAL ) {
      alert("JSN_TOTAL!");
      return;
    }	
    for( var m = 0; m < JSN_TOTAL; m++) {
      this.jsn_tab[m]._new  = parseInt(tagList[1 + m]);
    }
  }   
  }    
  this.Run = function(){
    setTimeout( "newAJAXCommand('status.xml', updateStatusLaurent, true)", 1000 );
  }
}

var bLaurentExists_XX = false;
var ObjLaurent_XX = null;

function GetLaurentObject() {
  if( !bLaurentExists_XX ) {
     ObjLaurent_XX = new LaurentObject();
     bLaurentExists_XX = true;
  }
  return ObjLaurent_XX;
}

function updateStatusLaurent( xmlData ) {
  ObjLaurent_XX.UpdateStatus( xmlData );   
}

